// generated by classgen.pl
#include "Global.h"

#ifndef ASTEROID_H
#define ASTEROID_H

#define NUM_TEXTURES 9

// Asteroid sizes
#define LARGE 0
#define MED 1
#define SMALL 2

typedef CL_OpenGLSurface* CL_TexturePtr;

// =============================================================================
// The Asteroid class represents individual asteroids. It also statically stores
// the textures used to display them.
// =============================================================================

class Asteroid : public WorldObject {

public:
	// =========================================================================
	// Functions
	// =========================================================================	
	Asteroid();
	~Asteroid();

	void update(float timeScale);
	void paint();

	void isHit();
	bool isRemovable() { return (!alive && explosionParticles.hasNoAnimations()); };
	bool isExpired() { return !alive; };
	const char *getName() { return "Asteroid"; };

	void pickRandomLocation();

	// =========================================================================
	// Static
	// =========================================================================
	static CL_TexturePtr asteroidTexture[NUM_TEXTURES];
	static bool texturesLoaded;

	// =========================================================================
	// Members
	// =========================================================================
	int texture, asteroidSize, asteroidID;
private:
	float dHeading;
	bool alive;

	ExplosionParticleContainer explosionParticles;
};

#endif
//
