#include "Bullet.h"

CL_OpenGLSurface *Bullet::bulletTexture;
bool Bullet::textureLoaded = false;

// Constructor
Bullet::Bullet() {
	bulletParticles.setInactive();
}

Bullet::Bullet(WorldObject *shipFiredFrom, float r, float g, float b) {

	this->shipFiredFrom = shipFiredFrom;
	timeAlive = 0;
	this->heading = shipFiredFrom->heading;

	Vector2 offset(shipFiredFrom->heading, 35);

	this->x = shipFiredFrom->x+offset.getX(); this->y = shipFiredFrom->y+offset.getY();

	size = 18;

	bound.setBoundingCircle(this, 10);
	
	if (!textureLoaded) {
		bulletTexture = new CL_OpenGLSurface("Graphics/bullet", WorldObject::manager);
		textureLoaded = true;
	}

	velocity.addVector(Vector2(heading, shipFiredFrom->velocity.magnitude+175));

	bulletParticles.setRate(75);
	bulletParticles.setBaseObject(this);
	bulletParticles.setColor(r, g, b);
}

// Destructor
Bullet::~Bullet() {
	
}

void Bullet::update(float timeScale) {

	x += (velocity*timeScale).getX();
	y += (velocity*timeScale).getY();
	heading += 10;

	timeAlive += timeScale;

	bulletParticles.update(timeScale);
}

void Bullet::paint() {

	bulletTexture->bind();
	paintOverlap();

	bulletParticles.paint();
}

bool Bullet::isExpired() {

	if (timeAlive > 2) {
		bulletParticles.setInactive();
		return true;
	} else 
		return false;

}

bool Bullet::isRemovable(){ 
	return (timeAlive > 2 && bulletParticles.hasNoAnimations()); 
}

void Bullet::isHit() {

	timeAlive = 2;
	bulletParticles.setInactive();
};
