// generated by classgen.pl
#include "Global.h"

// States
#define STATE_LEVEL_STARTING 0
#define STATE_LEVEL_PLAYING 1
#define STATE_LEVEL_COMPLETE 2
#define STATE_RESPAWNING 3
#define STATE_PAUSED 4
#define STATE_GAME_OVER 5

#ifndef GAME_H
#define GAME_H

// =============================================================================
// The Game class controls the in-game portion of asteroids, including the main 
// game loop, painting and updating, displaying messages, and collision detection. 
// =============================================================================

class Game : public GameScreen {

public:
	// =========================================================================
	// Functions
	// =========================================================================
	Game();
	~Game();

	virtual void run();
	virtual void paint();
	void initGL();
	void resizeGLScene();
	void handleKey();
	void restartGame();
	virtual void newLevel();
	void detectCollisions();
	void paintAccuracyRounds();
	void paintLivesRemaining();

	// =========================================================================
	// Static
	// =========================================================================
	static bool debug;
	static CL_Font *font;

	// =========================================================================
	// Members
	// =========================================================================
	Ship *ship;
	Asteroids *asteroids;

protected:

	int gameLevel, score, accuracyRounds, powerupsOn, currentState, pointsDoubled;
	bool paused, levelStarting, levelPlaying, levelComplete, respawning, debugShowFPS, doublingPoints;
	float levelStartingDelay, levelCompleteDelay, respawnDelay, ufoDelay, timeScale;
	unsigned int lastTimerUpdate;
	
	Special *powerups;
	UFO *ufos;
	FPS fps;
	Resource resourceManager;
	Message message;
	Key keys[4];
};

#endif
//
