// generated by classgen.pl
#include "Global.h"

#ifndef SHIP_H
#define SHIP_H

// =============================================================================
// The Ship class represents the player and handles player inputs as well as the
// ship's interaction with the rest of the playing field. It paints the shield
// and ammo status bars. 
// =============================================================================

class Ship : public WorldObject {

public:
	// =========================================================================
	// Functions
	// =========================================================================
	Ship();
	~Ship();

	// Controls
	void accelerate();
	void turnCW();
	void turnCCW();
	void fireBullet();

	// Utilities
	void bulletHitSomething();
	void startShip();
	void paintHUD();
	void clearBulletList();
	void bounceOffObject(WorldObject *objectHit, int deflection);
	void handleKey();
	void setGameStatePointer(int *gameState) { this->gameState = gameState; };

	// Worldobjects (required)
	virtual void update(float timeScale);
	virtual void paint();

	void isHit();
	bool isExpired() { return !alive; };
	bool isRemovable() { return (!alive && exhaust.hasNoAnimations() && explosionParticles.hasNoAnimations()); };
	const char *getName() { return "Ship"; };

	// =========================================================================
	// Static
	// =========================================================================
	static bool texturesLoaded;
	static CL_OpenGLSurface *shipTexture, *shipThrustingTexture, *shieldTexture, *hudCurve, *hudCurveMask, *accuracy;

	// =========================================================================
	// Members
	// =========================================================================
	int shots, hits, lives, *gameState;
	float shieldPower, ammoPower, dHeading, timeScale, timeElapsed, timeSinceLastAccelerate, timeSinceLastShield;
	bool accelerating, turning, shield, alive, timeElapsing;

	SimpleList<Bullet> bulletsFired;
	SimpleList<Bullet> *getBulletsList();

	ExhaustParticleContainer exhaust;
	ExplosionParticleContainer explosionParticles;

	Powerup shieldPowerup, gunPowerup, lifePowerup;

	Key keys[1];
};

#endif
//
