// generated by classgen.pl
#include "Global.h"

#ifndef WORLDOBJECT_H
#define WORLDOBJECT_H

// =============================================================================
// WorldObject is the base class for all playing field objects (not including
// particles, backdrops, or HUD). It contains common code for painting and 
// collision detection.
// =============================================================================

class WorldObject {

public:
	// =========================================================================
	// Functions
	// =========================================================================
	WorldObject();
	virtual ~WorldObject();

	virtual void update(float timeScale) = 0;
	virtual void paint() = 0;

	virtual void isHit() = 0;
	virtual bool isExpired() = 0;
	virtual bool isRemovable() = 0;
	virtual const char *getName() = 0;

	bool collides(BoundCircle &bnd);
	void paintOverlap();

	bool isOverlappedX();
	bool isOverlappedY();
	
	float getOverlapOffsetX();
	float getOverlapOffsetY();

	// =========================================================================
	// Members
	// =========================================================================
	float size, x, y, heading;
	Vector2 velocity, acceleration;
	BoundCircle bound;

	// =========================================================================
	// Static
	// =========================================================================
	static CL_ResourceManager *manager;
        static CL_OpenGLState* glState;
};

#endif
//
